#!/usr/bin/env python3
# -*- coding: utf-8 -*-
# Jussi Määttä, 2014

# Output Chapter I of "Alice in Wonderland", converted to lower-case
# and with all characters except a-z and ' ' discarded.
#
# Requires the file 11.txt.utf-8 from Project Gutenberg, available at
# <http://www.gutenberg.org/ebooks/11.txt.utf-8>.
#
# Usage:
#
#     alice.py

import sys
import string

file_name = "11.txt.utf-8"
s_begin = "CHAPTER I."
s_end = "off the cake."

alice = open(file_name, 'r').read()
i_begin = alice.find(s_begin)
i_end = alice.find(s_end) + len(s_end)

if i_begin == -1 or i_end == -1 or i_begin >= i_end:
    raise RuntimeError("Unexpected content in " + file_name)

s = alice[i_begin:i_end].lower()
f = lambda x: x in string.ascii_lowercase or x == ' '
sys.stdout.write(''.join(filter(f, s)))