#!/usr/bin/env python3
# -*- coding: utf-8 -*-
# Jussi Määttä, 2014

# Decode binary input using a given codebook. If a symbol ends with a '#',
# the '#' is removed.
#
# Usage:
#
#     decode.py codebook.json < input > output
#
# where codebook.json contains the output of build_codebook.py.

import json
import sys

codebook = json.loads(open(sys.argv[1]).read())
codebook = { value: key for (key, value) in codebook.items() }

codeword = ''
for bit in sys.stdin.read():
    codeword = codeword + bit
    symbol = codebook.get(codeword)
    if symbol != None:
        if symbol[-1] == "#":
            symbol = symbol[:-1]
        sys.stdout.write(symbol)
        codeword = ''

if codeword != '':
    raise RuntimeError('Broken input')